const app = require("express")();
const http = require('http');
var database=require('../../database/config');

//Default at 8090 to enable easy development
const appid = process.env.APPID || 8090;

//OLD (Single point)
app.get("/generatePoint", (req,res) => {
  console.log("Generating single point")
  res.send({"appid": appid, "point": generatePoint()})
})

//Sends the stream Had to limit the speed with intervals
// Otherwise it sends 2.000.000+ points a sec
app.get("/generatePointStream",(req,res)=>{

  let modelID = req.query.modelID;
  console.log(modelID);


  //temp disable
  streamGeneratedPoints(res);
  return

  if(modelID == "undefined"){
    streamGeneratedPoints(res);
  }
  else{
    streamDatabasePoints(res)
  }
})

function streamDatabasePoints(res){
  console.log("Sending database points")
  var result = database.executeQuery("SELECT * from SAMPLE.dbo.pointTable");
  
  console.log(result);
}


function streamGeneratedPoints(res){


  console.log("Sending generated points");
  var intervalId = setInterval(function(){    

    for(var i = 0; i<100;i++){
      var response = JSON.stringify({"appid": appid,"point":generatePoint()})
      res.write(response + "\n");
    }
    setTimeout(function() {
      clearInterval(intervalId)
      res.end();

    }, 10000);

},10);
}


//Generate randomPoint
function generatePoint(){
    console.log
    var xVal = Math.floor(Math.random()*100);
    var yVal = Math.floor(Math.random()*100);    
    return {id:appid, x:xVal,y:yVal};
  }

app.listen(appid, ()=>console.log(`${appid} is listening on ${appid}`))
  
  